<template>
  <transition v-if="showModal" name="modal">
    <div class="modal-mask" @click.self="modalClosed">
      <div class="modal-wrapper">
        <div
          id="modal-content"
          class="modal-container white-popup"
          :style="'max-width: ' + width + 'px'"
          @click.self="modalOpen"
        >
          <div v-if="$slots.header" class="modal-header">
            <slot name="header"></slot>
          </div>
          <div v-if="$slots.body" class="modal-body">
            <slot name="body"></slot>
          </div>
          <div v-if="$slots.footer" class="modal-footer">
            <slot name="footer"></slot>
          </div>
          <!-- <
            v-if="closeBtn"
          title="Đóng"
          type="button"
          class="mfp-close"
          @click="showModal = false"
        >
          ×
        </button> -->
        </div>
      </div>
    </div>
  </transition>
</template>
<script>
import { EventBus } from '~/plugins/bus'
export default {
  props: {
    width: {
      type: Number,
      default: 440,
    },
    closeBtn: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      showModal: false,
    }
  },
  created() {
    EventBus.$on('open-modal-login', (el) => {
      el === true ? this.modalOpen() : this.modalClosed()
    })
  },
  mounted() {},
  beforeDestroy() {
    this._unlockBody()
  },
  methods: {
    modalClosed() {
      this.showModal = false
      this._unlockBody()
      this.$emit('open-modal-login', false)
    },
    modalOpen() {
      this.showModal = true
      this._lockBody()
      this.$emit('open-modal-login', true)
    },
    _lockBody() {
      document.body.style.paddingRight = '17px'
      document.body.style.overflow = 'hidden'
      document.body.style.height = '100%'
    },
    _unlockBody() {
      document.body.style.paddingRight = ''
      document.body.style.overflow = ''
      document.body.style.height = ''
    },
  },
}
</script>
